<html>
    <head>
        <meta charset="utf-8">
        <title>Task 25.40 order detail</title>
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
        <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
        <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
        </head>
        <body onload="onPageLoading()">
            <div class="container">
             <p class="h3 text-left mt-5 "> Order Detai!!! </p>
             <div class="form-group col-12">
               <!-- <hr class="mt-5 mb-5" /> -->
             </div>
         
             <div class="form-group">
               <label>Order Code(mã đơn hàng):</label>
               <input class="form-control" id="id-code" placeholder="...">
             </div>
             <div class="form-group">
                 <label>Có Combo:</label>
                 <select class="form-control" id="combo-select">
                   <option valued="COM_BO">...</option>
                 </select>
               </div>
               <div class="form-group">
                 <label>Đường kính Pizza</label>
                 <input class="form-control" id="inp-duong-kinh" placeholder="...">
               </div>
               <div class="form-group">
                 <label>Sườn nướng(miếng)</label>
                 <input class="form-control" id="inp-suong-nuong">
               </div>
               <div class="form-group">
                 <label>Đồ uống</label>
                 <select class="form-control" id="drink-select">
                   <option valued="">...</option>
                 </select>
               </div>
               <div class="form-group">
                 <label>Số lượng nước uống</label>
                 <input class="form-control" id="number-select">
               </div>
               <div class="form-group">
                 <label>Voucher ID</label>
                 <input class="form-control" id="inp-voucherid">
               </div>
               <div class="form-group">
                 <label>Loại pizza</label>
                 <input class="form-control" id="inp-pizza">
               </div>
               <div class="form-group">
                 <label>Salad</label>
                 <input class="form-control" id="inp-Salad">
               </div>
               <div class="form-group">
                 <label>Thành tiền</label>
                 <input class="form-control" id="prices">
               </div>
               <div class="form-group">
                 <label>Giảm giá</label>
                 <input class="form-control" id="inp-giam-gia">
               </div>
               <div class="form-group">
                 <label>Họ và tên</label>
                 <input class="form-control" id="fullname">
               </div>
               <div class="form-group">
                 <label>Email</label>
                 <input class="form-control" id="Email">
               </div>
               <div class="form-group">
                 <label>Số điện thoại</label>
                 <input class="form-control" id="inp-mobile">
               </div>
               <div class="form-group">
                 <label>Địa chỉ</label>
                 <input class="form-control" id="inp-adress">
               </div>
               <div class="form-group">
                 <label>Lời nhắn</label>
                 <input class="form-control" id="inp-message">
               </div>
               <div class="form-group">
                 <label> Trạng thái đơn hàng</label>
                 <input class="form-control" id="inp-status">
               </div>
               <div class="form-group">
                 <label>Ngày tạo đơn</label>
                 <input class="form-control" id="inp-creat-order">
               </div>
               <div class="form-group">
                 <label>Ngày cập nhật</label>
                 <input class="form-control" id="inp-update">
               </div>
               <div class="form-group">
                    <button class="btn btn-success" onclick="onBtnConfirmClick()">Confirm</button>
                    <button class="btn btn-info" onclick="onBtnCancelClick()">Cancel</button>
               </div>
           </div> 
         </body>
         <script>
            "use strict";
            // biến chung 
            const gREQUEST_STATUS_OK = 200;
            const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
            var gOderCode = "";
            var gId = 0;
            //hàm xử lí sự kiện
            function onPageLoading() {
                getIdAndOderCode();
                if (validateThongTin(gId,gOderCode) === 1){
                    var vXmlHttpGetOrderById = new XMLHttpRequest();
                    callAPICreateOder(vXmlHttpGetOrderById,gOderCode);
                    hienThiThongTin(vXmlHttpGetOrderById);
                }
            }
            function onBtnConfirmClick(){
              var vConfirmObj = {
                trangThai: "confirmed"
              }
              var vXmlHttpUpdateOrder = new XMLHttpRequest();
              callAPIUpDate(vXmlHttpUpdateOrder,vConfirmObj);
              hienThiUpdate(vXmlHttpUpdateOrder);
            }
            function onBtnCancelClick(){
              var vConfirmObj = {
                trangThai: "cancel"
              }
              var vXmlHttpUpdateOrder = new XMLHttpRequest();
              callAPIUpDate(vXmlHttpUpdateOrder,vConfirmObj);
              hienThiUpdate(vXmlHttpUpdateOrder);
            }
            // hàm chung
            function getIdAndOderCode(){
                var vUrlString = window.location.href; //đường đẫn gọi đến trang
                var vUrl = new URL(vUrlString);
                gOderCode = vUrl.searchParams.get("odercode");
                gId = vUrl.searchParams.get("id");
                console.log("oder code: " + gOderCode);
                console.log("ID: " + gId);
            }
            function validateThongTin(paramId,paramOderCode) {
                if (paramId === 0 || paramOderCode === "") {
                    alert("thất bại")
                }else return 1;
            }
            function callAPICreateOder(paramXhttp,paramOderCode){
                const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
                paramXhttp.open("GET", vBASE_URL + "/" + paramOderCode, true);
                paramXhttp.send();

            }
            function hienThiThongTin(paramXhttp){
                paramXhttp.onreadystatechange =
                    function () {
                        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                            console.log(paramXhttp.responseText);
                            var vRespone = JSON.parse(paramXhttp.responseText);
                            var vOderCodeInp = document.getElementById("id-code");
                            var vCombo = document.getElementById("combo-select");
                            var vDuongKinh = document.getElementById("inp-duong-kinh");
                            var vSuon = document.getElementById("inp-suong-nuong");
                            var vDoUong = document.getElementById("drink-select");
                            var vSoLuongNuoc = document.getElementById("number-select");
                            var vVoucher = document.getElementById("inp-voucherid");
                            var vPizza = document.getElementById("inp-pizza");
                            var vSalad = document.getElementById("inp-Salad");
                            var vPrice = document.getElementById("prices");
                            var vGiamGia = document.getElementById("inp-giam-gia");
                            var vHoVaTen = document.getElementById("fullname");
                            var vEmail = document.getElementById("Email");
                            var vDienThoai = document.getElementById("inp-mobile");
                            var vDiaChi = document.getElementById("inp-adress");
                            var vLoiNhan = document.getElementById("inp-message");
                            var vStatus = document.getElementById("inp-status");
                            var vCreatedOrder = document.getElementById("inp-creat-order");
                            var vUpdate = document.getElementById("inp-update");
                            vOderCodeInp.value = vRespone.orderCode;
                            vDuongKinh.value =  vRespone.duongKinh;
                            vCombo.options[vCombo.selectedIndex].text = vRespone.kichCo;
                            vSuon.value = vRespone.suon ;
                            vSalad.value = vRespone.salad ;
                            vPizza.value = vRespone.loaiPizza ;
                            vVoucher.value = vRespone.idVourcher ;
                            vPrice.value = vRespone.thanhTien ;
                            vGiamGia.value = vRespone.giamGia ;
                            vDoUong.options[vDoUong.selectedIndex].text = vRespone.idLoaiNuocUong ;
                            vSoLuongNuoc.value = vRespone.soLuongNuoc ;
                            vHoVaTen.value = vRespone.hoTen ;
                            vEmail.value = vRespone.email ;
                            vDienThoai.value = vRespone.soDienThoai ;
                            vDiaChi.value = vRespone.diaChi ;
                            vLoiNhan.value = vRespone.loiNhan ;
                            vStatus.value = vRespone.trangThai ;
                            vCreatedOrder.value = vRespone.ngayTao ;
                            vUpdate.value = vRespone.ngayCapNhat ;

                        }
                    }
            }
            function callAPIUpDate(paramXhttp,paramObj) {
                  //base url
                  const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
                  var vId = gId; //  là id (66684) của đơn hàng (không phải là orderCode (mã đơn hàng: hdZJRBKkPS)) 
                  paramXhttp.open("PUT", vBASE_URL + "/" + vId);
                  paramXhttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
                  paramXhttp.send(JSON.stringify(paramObj));

            }
            function hienThiUpdate(paramXhttp) {
              paramXhttp.onreadystatechange =
                      function () {
                          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                              var vUpdatedOrder = paramXhttp.responseText;
                              console.log(vUpdatedOrder);
                              alert("Cập nhật thành công");
                          }                        
                      }
            }
         </script>
</html>